//Раздел констант
const
 int //grid=32,//32,//размер ячейки сетки уровня
     lev_width=32,//размеры уровня по X
     lev_height=24,//размеры уровня по Y

     lev_num_max=lev_width*lev_height,//максимальное количество элементов уровня
     obj_num_max=lev_width*lev_height,//максимальное количество объектов

     eff_num_max=99;//максимальное количество эффектов

//Record
struct lev_type //сетка уровня
 { 
  int x,
      y,
      texture,
      exit_score,//очки на выход от бонусов
      exit_kills;//очки на выход от врагов
 }
lev[lev_num_max];

struct obj_type //сетка объектов
 { 
  int x,
      y,
      texture;
 }
obj[obj_num_max];

char buff[200],//для загрузки индексированных текстур
     txt_tmp[25];//для цифр текста [колво символов]

int grid,//размер ячейки сетки уровня

    x_cam,//координаты камеры
    y_cam,

    delta;


//переменные колобка
int p_x,//координаты колобка
    p_y, 
    p_move_x,//смещение при движении колобка по OX
    p_move_y,//смещение при движении колобка по OY
    p_vector,//вектор направления движения
    p_vector_nuke,//вектор направления взгляда при попытке взрыва
    p_vector_old_left_right,//старое напр. движения влево или вправо для анимации вверх или вниз
    p_frame,//кадр колобка
    p_frame_count,//временной счетчик между кадрами анимации
    p_move_stage,//стадия управления движением колобка
    p_kick_left_obj_N,//индекс тычкнутого объекта слева
    p_kick_right_obj_N,//индекс тычкнутого объекта справа
    p_score,//количесвто очков
    p_live,//количесвто жизней
    p_kal[lev_num_max];//остатки от печатных плат (1-го типа lev[]) 

bool p_move_left,//движется влево
     p_move_right,
     p_move_up,   
     p_move_down,
     p_move_left_v,//может ли двигаьтся влево 
     p_move_right_v,     
     p_move_up_v,     
     p_move_down_v, 
     p_kick_left, 
     p_kick_right,
     p_true;//определяет жив ли колобок


//телепорт как в portal
int t1x,t1y,t2x,t2y;//координаты входа и выхода из телепорта
bool t1_true,t2_true;//определяет есть ли телепорты


//переменные динамических(которые могут перемещаться) объектов
int obj_index[obj_num_max],//индекс объекта
    obj_move_x[obj_num_max],//смещение
    obj_move_y[obj_num_max],
    obj_delta[obj_num_max],//угол поворота относительно центра
    obj_rotate[obj_num_max],//определяет тип кручения объекта 1 - при движении, 2- все время
    obj_AI_rnd[obj_num_max],//для перемещения объекта - псевдо АИ
    obj_sleep_count[obj_num_max],//таймер покоя, после падения = 5,затем вычитается до 0
    
    obj_nuke_index,//индекс взрывающегося объекта
    obj_nuke_count[obj_num_max];//счетчик до взрыва объекта

bool obj_move[obj_num_max],//объект движется
     obj_move_up[obj_num_max],
     obj_move_down[obj_num_max],
     obj_move_left[obj_num_max],
     obj_move_right[obj_num_max],
     obj_move_up_v[obj_num_max],//объект может двинутся вверх
     obj_move_down_v[obj_num_max],
     obj_move_left_v[obj_num_max],
     obj_move_right_v[obj_num_max],
     
     //для проверок на сваливаемость для элементов OBJ 1,2
     obj_move_up_left_v[obj_num_max],//вверх-влево
     obj_move_up_right_v[obj_num_max],//вверх-вправо
     obj_move_down_left_v[obj_num_max],//вниз-влево
     obj_move_down_right_v[obj_num_max],//вниз-вправо
     
     obj_move_kick_left_mark[obj_num_max],//отмечен для тычка слева
     obj_move_kick_right_mark[obj_num_max],//отмечен для тычка справа

     obj_dead[obj_num_max],//мертв ли объект
     obj_nuke[obj_num_max];//объект на подрыве

//переменные для проверки некоторых коллизий
int lev_matrix[lev_width+1][lev_height+1],//матрица уровня
    obj_matrix[lev_width+1][lev_height+1];//матрица объектов


//переменные видео эффектов
int eff_x[eff_num_max],//кординаты
    eff_y[eff_num_max],
    eff_type[eff_num_max],//тип эфеектов взрыв,молния, и т.д.
    eff_W[eff_num_max],
    eff_H[eff_num_max],
    eff_cR[eff_num_max],//цвета RGB, прозрачность альфа 
    eff_cG[eff_num_max],
    eff_cB[eff_num_max],
    eff_cAlpha[eff_num_max],
    eff_counter[eff_num_max];//счетчик

bool eff_true[eff_num_max];//определяет существеут ли эффект

int num_level;//текущий номер уровня  

FILE *fp;//для записи и загрузки уровня

//Текстуры
GLuint player_texture[20], //хэндл текстур колобка
       obj_texture[10],//текстуры объектов
       t_texture,//текстура портала
       lev_texture[9],//текстуры уровня
       other_texture[10],//остальные текстуры
       eff_texture[2][999];//текстуры эффектов

//начальные значения всех переменных при старте
void InitGame() 
 {

 //параметры колобка при старте
  p_x=1;//место старта колобка по умолчанию
  p_y=1;
  p_move_x=0;
  p_move_y=0;
  p_move_stage=0;

  p_frame=1;//стартовый кадр
  p_frame_count=0;

  p_score=0;
  p_live=45;
  p_true=true;
  p_vector=1;   
  p_vector_nuke=2;
  p_vector_old_left_right=2;

  p_kick_left_obj_N=0;//индекс тычкнутого объекта слева
  p_kick_right_obj_N=0;//индекс тычкнутого объекта справа

  for(i=0;i<lev_num_max;i++) 
   {
    p_kal[i]=0;
   }

  p_move_left=false;//движется влево
  p_move_right=false;
  p_move_up=false;   
  p_move_down=false;
  p_move_left_v=false;//может ли двигаьтся влево 
  p_move_right_v=false;     
  p_move_up_v=false;     
  p_move_down_v=false; 
  p_kick_left=false; 
  p_kick_right=false;
  p_true=true;//определяет жив ли колобок

//начальные параметры телепорта
  t1x=0;
  t1y=0;
  t2x=0;
  t2y=0;//координаты входа и выхода из телепорта
  t1_true=false;
  t2_true=false;//определяет есть ли телепорты

//начальные параметры переменных элементов уровня
  for(j=0;j<lev_num_max;j++) 
   {
    lev[j].x=0;
    lev[j].y=0;
    lev[j].texture=0;
    lev[j].exit_score=0;
    lev[j].exit_kills=0;
   }

//начальные параметры переменных динамических объектов
  for(j=0;j<obj_num_max;j++) 
   {
    obj[j].x=0;
    obj[j].y=0;
    obj[j].texture=0;

    obj_index[j]=0;//индекс объекта
    obj_move_x[j]=0;//смещение
    obj_move_y[j]=0;
    obj_delta[j]=0;//угол поворота относительно центра
    obj_rotate[j]=0;//определяет тип кручения объекта 1 - при движении, 2- все время
    obj_AI_rnd[j]=0;//для перемещения объекта - псевдо АИ
    obj_sleep_count[j]=0;//таймер покоя, после падения = 5,затем вычитается до 0
    
    obj_nuke_count[j]=0;//счетчик до взрыва объекта

    obj_move[j]=false;//объект движется
    obj_move_up[j]=false;
    obj_move_down[j]=false;
    obj_move_left[j]=false;
    obj_move_right[j]=false;
    obj_move_up_v[j]=false;//объект может двинутся вверх
    obj_move_down_v[j]=false;
    obj_move_left_v[j]=false;
    obj_move_right_v[j]=false;
     
     //для проверок на сваливаемость для элементов OBJ 1,2
    obj_move_up_left_v[j]=false;//вверх-влево
    obj_move_up_right_v[j]=false;//вверх-вправо
    obj_move_down_left_v[j]=false;//вниз-влево
    obj_move_down_right_v[j]=false;//вниз-вправо
    
    obj_move_kick_left_mark[j]=false;//отмечен для тычка слева
    obj_move_kick_right_mark[j]=false;//отмечен для тычка справа

    obj_dead[j]=false;//мертв ли объект
    obj_nuke[j]=false;//объект на подрыве
   }//конец цикла

  obj_nuke_index=0;//индекс взрывающегося объекта

//обнуление матриц
  for(j=0;j<lev_width+1;j++)
  for(k=0;k<lev_height+1;k++)
   {
    obj_matrix[j][k]=0;
    lev_matrix[j][k]=0;
   }

//остальное
  x_cam=0;
  y_cam=0;
  
  delta=0;

 }

//грузим игровые текстуры
void Load_Game_Textures()
 {
  //Загрузка текстур колобка
  for(i=1;i<8+1;i++)
   {
    sprintf(buff,"data/img/player/%i.png",i);
    load(buff, player_texture[i]);
   }

  //Загрузка текстур объектов
  for(i=1;i<3+1;i++)
   {
    sprintf(buff,"data/img/obj/%i.png",i);
    load(buff, obj_texture[i]);
   }

  //Загрузка текстур уровня
  for(i=1;i<7+1;i++)
   {
    sprintf(buff,"data/img/lev/%i.png",i);
    load(buff, lev_texture[i]);
   }
  
  //Загрузка текстур эффектов
  for(i=1;i<20+1;i++)
   {
    sprintf(buff,"data/img/gfx/boom/%i.png",i);
    load(buff, eff_texture[1][i]);
   }

  for(i=1;i<16+1;i++)
   {
    sprintf(buff,"data/img/gfx/light/%i.png",i);
    load(buff, eff_texture[2][i]);
   }

  load("data/img/gfx/swirl/swirl.png", t_texture);//текстура телепорта

  //Загрузка других текстур
  load("data/img/other/kal.png", other_texture[1]);
  load("data/img/other/livebar.png", other_texture[2]);
  load("data/img/other/hud.png", other_texture[3]);

  //Загрузка заднего игрового фона
  load("data/img/bground/1.jpg", background_texture);

 }

void Load_Level(int num_level)
 {
  sprintf(buff,"data/map/lev%i.dat",num_level);
  fp=fopen(buff,"r");
  fread((char *)lev, sizeof(struct lev_type), lev_num_max, fp);
  fclose (fp); 

  sprintf(buff,"data/map/obj%i.dat",num_level);
  fp=fopen(buff,"r");
  fread((char *)obj, sizeof(struct obj_type), obj_num_max, fp);
  fclose (fp);
 }

void Player_Start()//место старта колобка
 {
  for(i=0;i< lev_num_max;i++) 
   {
    if (lev[i].texture==1)//1-ый элемент-старт игрока
     {
      p_x=lev[i].x;
      p_y=lev[i].y; 
     }
   }//конец цикла
 }


void Matrix_ReFresh()//Рефреш матриц
 {
  //обновляем матрицу уровня
  for(i=0; i < lev_num_max; i++) 
   {
    lev_matrix[lev[i].x][lev[i].y]=lev[i].texture;
   }

  //обновляем матрицу объектов    
  for(j=0; j < obj_num_max; j++) 
   { 
    obj_index[j]=j;
    if (obj_dead[j]==false) {obj_matrix[obj[j].x][obj[j].y]=obj[j].texture;}
    if (obj_dead[j]==true) {obj_matrix[obj[j].x][obj[j].y]=0;}
   }
 }

void Player_Controls_KeyClick()//Управление при однократном нажатии клавиши
 {
  if (p_true==true) //Если колобок жив от им можно управлять
   {

    //Направление для подрыва бомбы
    if (keys[SDLK_LEFT]) {p_vector_nuke=4;} 
    if (keys[SDLK_RIGHT]) {p_vector_nuke=2;} 
    if (keys[SDLK_UP]) {p_vector_nuke=1;} 
    if (keys[SDLK_DOWN]) {p_vector_nuke=3;}

    //подраываем рядом стоящую бомбу 
    if (event.key.keysym.sym==SDLK_b)
     {
      for(j=0; j < obj_num_max; j++) 
       {
        if (p_score>=10 and
            obj[j].texture==2 and
            obj_matrix[obj[j].x][obj[j].y]==obj[j].texture and
            obj_dead[j]==false and //если объект жив
            obj_move[j]==false and
            obj_sleep_count[j]==0) 
         {
          if (obj[j].x==p_x and //1 нюкаем сверху
              obj[j].y==p_y+1 and
              p_vector_nuke==3 and
              obj_nuke[j]==false)
           {
            obj_nuke[j]=true;
            obj_nuke_count[j]=0;
            p_score=p_score-10;
            break;  
           }    

          if (obj[j].x==p_x and //2 нюкаем снизу
              obj[j].y==p_y-1 and
              p_vector_nuke==1 and
              obj_nuke[j]==false)
           {
            obj_nuke[j]=true;
            obj_nuke_count[j]=0;
            p_score=p_score-10;
            break;  
           }  

          if (obj[j].x==p_x-1 and//3 нюкаем слева
              obj[j].y==p_y and
              p_vector_nuke==4 and
              obj_nuke[j]==false)
           {
            obj_nuke[j]=true;
            obj_nuke_count[j]=0;
            p_score=p_score-10;
            break;  
           }    

          if (obj[j].x==p_x+1 and//4 нюкаем справа
              obj[j].y==p_y and
              p_vector_nuke==2 and
              obj_nuke[j]==false)
           {
            obj_nuke[j]=true;
            obj_nuke_count[j]=0;
            p_score=p_score-10;
            break;  
           }   

         }     
       }//конец цикла
      
     }//конец "подраываем рядом стоящую бомбу"

   //Установка входа в телепорт
   if ( keys[SDLK_n] ) 
    {
     t1_true=true;
     t1x=p_x;
     t1y=p_y;   
    } 

   //установка выхода из телепорта
   if ( keys[SDLK_m] ) 
    {
     t2_true=true;
     t2x=p_x;
     t2y=p_y;  
    } 

  }//конец "Если колобок жив от им можно управлять"

 }


void Player_Controls_KeyDown()//Управление при постоянном нажатии клавиши
 {
  if (p_true==true) //Если колобок жив от им можно управлять
   {
    //Управляем движением колобка
    if (keys[SDLK_LEFT] and p_move_stage==0)//влево
     {
      if (p_move_left_v==true )
       {
        p_move_left_v=false;
        p_move_left=true;
        p_vector=4;
        p_move_stage=1;
       
        p_frame=3;       

        p_move_right=false;
        p_move_up=false;
        p_move_down=false;
       } 
     }

    if (keys[SDLK_RIGHT] and p_move_stage==0)//вправо 
     {
      if (p_move_right_v==true)//вправо 
       {
        p_move_right_v=false;
        p_move_right=true;
        p_vector=2;
        p_move_stage=1;
        
        p_frame=5;

        p_move_left=false;
        p_move_up=false;
        p_move_down=false;
       } 
     } 

    if (keys[SDLK_UP] and p_move_stage==0)//вверх
     {
      if (p_move_up_v==true) 
       {
        p_move_up_v=false;
        p_move_up=true;
        p_vector=1;
        p_move_stage=1;

        if (p_vector_old_left_right==4) {p_frame=3;}//было раньше лево
        if (p_vector_old_left_right==2) {p_frame=5;}//было раньше право

        p_move_right=false;
        p_move_left=false;
        p_move_down=false;
       }
     }
    
    if (keys[SDLK_DOWN]and p_move_stage==0)//вниз
     {
      if (p_move_down_v==true) 
       {
        p_move_down_v=false;
        p_move_down=true;
        p_vector=3;
        p_move_stage=1;

        if (p_vector_old_left_right==4) {p_frame=3;}//было раньше лево
        if (p_vector_old_left_right==2) {p_frame=5;}//было раньше право

        p_move_right=false;
        p_move_left=false;
        p_move_up=false;
       } 
     } 

    //если колобок не может дальше пройти то он корчит рожи
    /*  
    if (keys[SDLK_LEFT] and p_move_left_v==false) {p_frame=7;}
    if (keys[SDLK_RIGHT] and p_move_right_v==false) {p_frame=8;}
    */

    //стоим тупо улыбаемся когда клавиши управления не нажаты
    if (keys[SDLK_UP]==false and
        keys[SDLK_DOWN]==false and 
        keys[SDLK_LEFT]==false and 
        keys[SDLK_RIGHT]==false and 
        p_move_stage==0) 
     {
      p_frame=1;
     }

   }//конец "Если колобок жив от им можно управлять"
 }


void Player_Render_Move()//Обработка движений колобка
 {
  if (p_true==true) //Если колобок жив, то
   {
    
    if (p_move_stage==1)//стадия передвижения
     { 

      //вверх
      if (p_move_up==true and
          p_vector==1) 
       {
        p_move_y=p_move_y-0.08*grid;//скорость продвижения между клетками 
  
        if (p_move_y<-grid) //окончание передвижения
         {
          p_y=p_y-1;//после передвижения передвигаемся на новую клетку физически
          p_move_y=0;
          p_move_up=false;
          p_vector=0;
          p_move_stage=0;
         }
       }

      //вниз
      if (p_move_down==true and
          p_vector==3) 
       {
        p_move_y=p_move_y+0.08*grid;//скорость продвижения между клетками
 
        if (p_move_y>grid) //окончание передвижения
         {
          p_y=p_y+1;//после передвижения передвигаемся на новую клетку физически
          p_move_y=0;
          p_move_down=false;
          p_vector=0;
          p_move_stage=0;
         }
       }
 
      //влево
      if (p_move_left==true and
          p_vector==4) 
       {
        p_move_x=p_move_x-0.08*grid;//скорость продвижения между клетками
  
        if (p_move_x<-grid) //окончание передвижения
         {
          p_x=p_x-1;//после передвижения передвигаемся на новую клетку физически
          p_move_x=0;
          p_move_left=false;
          p_vector_old_left_right=p_vector;
          p_vector=0;
          p_move_stage=0;
         }
       }

      //вправо
      if (p_move_right==true and
          p_vector==2) 
       {
        p_move_x=p_move_x+0.08*grid;//скорость продвижения между клетками
  
        if (p_move_x>grid) //окончание передвижения
         {
          p_x=p_x+1;//после передвижения передвигаемся на новую клетку физически
          p_move_x=0;
          p_move_right=false;
          p_vector_old_left_right=p_vector;
          p_vector=0;
          p_move_stage=0;
         }
       }
  
      //анимация в движении-подглючивает анимация^(
      p_frame_count=p_frame_count+1; //задержка в шаге смене кадров
 
      if (p_frame_count>=4)//задержка в смене кадров 
       {
        p_frame_count=0;
        p_frame=p_frame+1;//смена кадра
       
        //Если колобок движется влево или вправо
        if (p_move_left==true and
            p_vector==4 and
            p_frame>4) {p_frame=3;}

        if (p_move_right==true and
            p_vector==2 and 
            p_frame>6) {p_frame=5;}
 
        //если колобок движется вверх или вниз то
        if (p_move_up==true and p_vector==1 or 
            p_move_down==true and p_vector==3)
         {
          if (p_vector_old_left_right==4 and p_frame>4) {p_frame=3;}//было раньше лево
          if (p_vector_old_left_right==2 and p_frame>6) {p_frame=5;}//было раньше право
         }
       }

     }//конец стадии передвижения 1

/*

    //Ограничение передвижения колобка внутри монитора-границы игрового экрана
    if (edit==false)//если отключен режим редактора то привязка камеры к клавиатуре отменяется 
     {
*/

    //перемещение игрового экрана-камеры
    if ((p_x*grid+x_cam)>(win_DX-7*grid)) {x_cam=x_cam-0.1*grid;}//смещение на 0.1 от grid
    if ((p_x*grid+x_cam)<(0+7*grid)) {x_cam=x_cam+0.1*grid;}
    if ((p_y*grid+y_cam)>(win_DY-4*grid)) {y_cam=y_cam-0.1*grid;}
    if ((p_y*grid+y_cam)<(0+4*grid)) {y_cam=y_cam+0.1*grid;}
 
/*   }  */


  //Ограничение передвижения колобка внутри игрового чистого поля
    if (p_x>lev_width) {p_x=lev_width;} 
    if (p_x<0) {p_x=0;}  
    if (p_y>lev_height) {p_y=lev_height;} 
    if (p_y<0) {p_y=0;}    

   }//конец если "Если колобок жив, то"
 }

 
void Player_Render_CollisionLevObj()//Обработка столконвений колобка c lev и obj
 {
  if (p_true==true) //Если колобок жив, то
   {
    //Проверка возможности перемещения колобка на новую клетку
    p_move_left_v=true;
    p_move_right_v=true;
    p_move_up_v=true;
    p_move_down_v=true;

    //1) Взаимодействие колобка с LEV
    //фильтрация возможностей для матрицы lev (>4)
    if (lev_matrix[p_x-1][p_y]>4) {p_move_left_v=false;} //слева
    if (lev_matrix[p_x+1][p_y]>4) {p_move_right_v=false;} //справа
    if (lev_matrix[p_x][p_y-1]>4) {p_move_up_v=false;} //сверху
    if (lev_matrix[p_x][p_y+1]>4) {p_move_down_v=false;} //снизу

    //Если заходим колобком на зеленый элемент lev (=4), то стираем его
    if (lev_matrix[p_x][p_y]==4)
     {
      lev_matrix[p_x][p_y]==0;//ХЗ надо ли, т.к. ниже уже есть обновление матрицы
      for(i=0; i < lev_num_max; i++) 
       {
        if (lev[i].x==p_x and 
            lev[i].y==p_y and
            lev[i].texture==4)
         {
          lev[i].texture=0;
          p_kal[i]=true;//оставляем кал
         }
       }  
     }

    //Если заходим колобком на элемент lev (=2,3-по молекулам,по вихрям), то выход из уровня
    if (lev_matrix[p_x][p_y]==2 or 
        lev_matrix[p_x][p_y]==3)
     {
      for(i=0; i < lev_num_max; i++) 
       {
        if (lev[i].x==p_x and 
            lev[i].y==p_y and
            lev[i].texture==2 or
            lev[i].x==p_x and 
            lev[i].y==p_y and
            lev[i].texture==3)   
         {
          //выход 
          if (lev[i].texture==2 and //если собрано нужное количество очков
              p_score>=lev[i].exit_score
              or
              lev[i].texture==3 and //если скокото вихрей сдохло
              lev[i].exit_kills<=0) //грузим следущий уровень
           {        
            InitGame();
            num_level++;
            Load_Level(num_level);
            Player_Start();
           }

         }
       }
     }

    //2)Взаимодействие колобка с obj, и при этом определяем границы движения колобка 
    //Тычки объектов колобком 
    if (p_move_stage==0)//снимаем метки тычка
     {
      p_kick_left=false;
      p_kick_right=false;
  
      for(j=0; j < obj_num_max; j++) 
       {
        if (obj_dead[j]==false)//если объект жив
         { 
          if (obj_move_kick_left_mark[j]==true) {obj_move_kick_left_mark[j]=false;}
          if (obj_move_kick_right_mark[j]==true) {obj_move_kick_right_mark[j]=false;} 
         } 
       }
     }

     
    for(j=0; j < obj_num_max; j++) 
     {
      //ищем объекты для тычка
      //слева - глюк в полете может быть сдвинута??
      if (obj_dead[j]==false and //если объект жив
          obj[j].texture==2 and 
          obj[j].x==p_x-1 and 
          obj[j].y==p_y and 
          obj_move[j]==false and
       // obj_move_down[j]==false and
          obj_move_left[j]==false)
       {
        obj_move_kick_left_mark[j]=true;//ставим метку
       
        if (obj_move_left_v[j]==true) 
         {  
          p_kick_left_obj_N=j;//берем индекс
          p_kick_left=true;
          p_move_left_v=true;
         }
          
        //если объект не может дальше двигатся то и колобок тоже
        if (obj_move_left_v[j]==false) {p_move_left_v=false;}
       }

      //справа
      if (obj_dead[j]==false and //если объект жив
          obj[j].texture==2 and 
          obj[j].x==p_x+1 and 
          obj[j].y==p_y and 
          obj_move[j]==false and
       // obj_move_down[j]==false and
          obj_move_right[j]==false)
       {
        obj_move_kick_right_mark[j]=true;//ставим метку

        if (obj_move_right_v[j]==true) 
         {  
          p_kick_right_obj_N=j;//берем индекс-ставим метку
          p_kick_right=true;
          p_move_right_v=true;
         }

        //если объект не может дальше двигатся то и колобок тоже
        if (obj_move_right_v[j]==false) {p_move_right_v=false;}
       }

     }//конец цикла

    //Реализация тычка при движении объект влево
    if (p_kick_left==true and
        p_y==obj[p_kick_left_obj_N].y and
        p_kick_left_obj_N>=0 and //ГЛЮК С НУЛЕВЫМ ОБЪЕКТОМ если не ставить = то 0-ой объект не катится именно здесь!!!!
        p_move_left==true)
     {
      //если объект толкаем,то дополнительно передвигаем чтобы придти раньше колобка     
      obj_move_x[p_kick_left_obj_N]=obj_move_x[p_kick_left_obj_N]-1;
      obj_move[p_kick_left_obj_N]=true;
      obj_move_left[p_kick_left_obj_N]=true;

      obj_rotate[p_kick_left_obj_N]=1;//меченый объект крутится при движени

      obj_move_left_v[p_kick_left_obj_N]=false;

      p_kick_left=false; 
    
      p_kick_left_obj_N=0;//снимаем метку
     }

    //Реализация тычка при движении объект вправо
    if (p_kick_right==true and
        p_y==obj[p_kick_right_obj_N].y and
        p_kick_right_obj_N>=0 and 
        p_move_right==true)
     {
      //если объект толкаем, то дополнительно передвигаем чтобы придти раньше колобка     
      obj_move_x[p_kick_right_obj_N]=obj_move_x[p_kick_right_obj_N]+1;
      obj_move[p_kick_right_obj_N]=true;
      obj_move_right[p_kick_right_obj_N]=true;

      obj_rotate[p_kick_right_obj_N]=1;//крутится при движени

      obj_move_right_v[p_kick_right_obj_N]=false;

      p_kick_right=false;

      p_kick_right_obj_N=0;
     }

    //сверху-колобок неможет пройти
    if (obj_matrix[p_x][p_y-1]==2) {p_move_up_v=false;}
    //снизу-колобок неможет пройти
    if (obj_matrix[p_x][p_y+1]==2) {p_move_down_v=false;}

   }//конец "Если колобок жив, то"

 }


void Object_Render_Exit()//если вихрь заходит на спец выход то дохнет, а очки на выход уменьшаються
 {
  for(i=0; i < lev_num_max; i++) 
  for(j=0; j < obj_num_max; j++)
   {
    if (lev[i].texture==3 and //если вихрь залетает на 3-ий элемент lev (условие как с телепортом)
        lev[i].exit_kills>0 and
        obj_dead[j]==false and //если объект жив
        obj[j].texture==3 and //вихрь   
        obj[j].x==lev[i].x and
        obj[j].y==lev[i].y and
        obj_matrix[obj[j].x][obj[j].y]==obj[j].texture)    
     {
      lev[i].exit_kills=lev[i].exit_kills-1;//уменьшаем очки выхода

      obj_matrix[lev[i].x][lev[i].y]=0;//стираем объект из матрицы объектов
      obj_matrix[obj[j].x][obj[j].y]=0; 

      //если объект двигался
      if (obj_move[j]==true)
       {
        if (obj_move_up[j]==true) {obj_matrix[obj[j].x][obj[j].y-1]=0;}
        if (obj_move_down[j]==true) {obj_matrix[obj[j].x][obj[j].y+1]=0;}
        if (obj_move_left[j]==true) {obj_matrix[obj[j].x][obj[j].y-1]=0;}
        if (obj_move_right[j]==true) {obj_matrix[obj[j].x][obj[j].y+1]=0;}
       }

      obj_dead[j]=true;//объект мертв-там будет вызрыв

     }
   }
 }


void Object_Render_Teleport()//Взаимодействие объекта с телепортом-попадание в телепорт объекта
 {
  if (t1_true==true and//Если существуют вход и выход из телепорта
      t2_true==true)
   {
    for (j=0; j < obj_num_max; j++) 
     {
      if (obj_dead[j]==false and //если объект жив
          obj[j].texture>0 and 
          obj[j].x==t1x and 
          obj[j].y==t1y and 
          obj_matrix[obj[j].x][obj[j].y]>0 and

          obj_matrix[t2x][t2y]==0)//если в месте выхода никого нету-выход чист
       {
        obj_matrix[obj[j].x][obj[j].y]=0;//затираем следы
        obj[j].x=t2x;//телепортация объекта в координаты выхода из телепорта
        obj[j].y=t2y;
        obj_matrix[obj[j].x][obj[j].y]=obj[j].texture;
       } 
     }
   }//конец "Если существуют вход и выход из телепорта"

 }

void Object_Render_Stage1()//Проверка возможности перемещения объекта
 {

  //Взаимодействие объектов между собой и уровнем
  for(j=0; j < obj_num_max; j++)
   {
    if (obj_dead[j]==false and //если объект жив
        obj_move[j]==false and //когда движение не происходит
        obj_matrix[obj[j].x][obj[j].y]>0)
     { 
      obj_move_left_v[j]=true;//возможны все направления движения
      obj_move_right_v[j]=true;
      obj_move_up_v[j]=true;
      obj_move_down_v[j]=true;  
       
      obj_move_up_left_v[j]=true;
      obj_move_up_right_v[j]=true;
      obj_move_down_left_v[j]=true;
      obj_move_down_right_v[j]=true;

      //фильтрация возможных направлений передвижения объекта по матрицам lev и obj 
      //слева
      if (lev_matrix[obj[j].x-1][obj[j].y]>3 or //по стартовым и выходам ходить может
          obj_matrix[obj[j].x-1][obj[j].y]>0) {obj_move_left_v[j]=false;}
      //справа
      if (lev_matrix[obj[j].x+1][obj[j].y]>3 or
          obj_matrix[obj[j].x+1][obj[j].y]>0) {obj_move_right_v[j]=false;}
      //сверху
      if (lev_matrix[obj[j].x][obj[j].y-1]>3 or
          obj_matrix[obj[j].x][obj[j].y-1]>0) {obj_move_up_v[j]=false;}
      //снизу
      if (lev_matrix[obj[j].x][obj[j].y+1]>3 or
          obj_matrix[obj[j].x][obj[j].y+1]>0) {obj_move_down_v[j]=false;}

      //сверху слева
      if (lev_matrix[obj[j].x-1][obj[j].y-1]>3 or
          obj_matrix[obj[j].x-1][obj[j].y-1]>0) {obj_move_up_left_v[j]=false;}
      //сверху справа
      if (lev_matrix[obj[j].x+1][obj[j].y-1]>3 or
          obj_matrix[obj[j].x+1][obj[j].y-1]>0) {obj_move_up_right_v[j]=false;}
      //снизу слева
      if (lev_matrix[obj[j].x-1][obj[j].y+1]>3 or
          obj_matrix[obj[j].x-1][obj[j].y+1]>0) {obj_move_down_left_v[j]=false;}
      //снизу справа
      if (lev_matrix[obj[j].x+1][obj[j].y+1]>3 or
          obj_matrix[obj[j].x+1][obj[j].y+1]>0) {obj_move_down_right_v[j]=false;}
     }

   }//конец цикла

  //проверка объекта-претендента на падение или перемещение на свободную клетку 
  for(j=0; j < obj_num_max; j++)
  for(k=0; k < obj_num_max; k++)
   {
    //взаимодействие объектов друг с другом-предотвращение слипания объектов при падении
    if (obj_dead[j]==false and //если объект j жив
        obj_dead[k]==false and //если объект k жив
        obj_matrix[obj[j].x][obj[j].y]>0 and
        obj_matrix[obj[k].x][obj[k].y]>0) 
     { 
      //1-случай 
      // 1j0k1
      // 11011 
      //чтобы в пропасть падали по ОДНОМУ, это правило будет действовать только при дырке в матрице уровня и объектов
      if (obj_move[j]==false and
          obj_move[k]==false and
          obj_move_right_v[j]==true and //если 2 объекта j и k одновременно готовы двигаться к яме между ними
          obj_move_left_v[k]==true and
          obj[j].y==obj[k].y and
          obj[j].x==obj[k].x-2 and 
          obj_matrix[obj[k].x-1][obj[k].y+1]==0 and //если есть куда падать в последствии через ход
          lev_matrix[obj[k].x-1][obj[k].y+1]==0 and //по матрицам obj и lev  
          obj_index[k]!=p_kick_left_obj_N and
          obj_move_kick_left_mark[k]==false)
       {
        obj_move_left_v[k]=false;//падает j-ый объект 
       }
      
      //2-случай
      // 1jk11
      // 11011
      //если пропасть занята летающим вниз объектом k,j-может упасть вправо 
      if (obj_move[j]==false and
          obj_move_right_v[j]==true and
          obj[j].y==obj[k].y+1 and
          obj[j].x==obj[k].x-1)
        {
         obj_move_right_v[j]=false;
        }

      //3-случай
      // 11kj1
      // 11011
      //если пропасть занята летающим вниз объектом k,j-может упасть влево 
      if (obj_move[j]==false and
          obj_move_left_v[j]==true and
          obj[j].y==obj[k].y+1 and
          obj[j].x==obj[k].x+1)
        {
         obj_move_left_v[j]=false;
        }

     }//конец условия

   }//конец циклов

  //если объект был в движении то отсчитываем счетчик до его состояния покоя
  for(j=0; j < obj_num_max; j++)
   {
    if (obj_dead[j]==false and //если объект жив
        obj_move[j]==false and
        obj_sleep_count[j]>0)
     {
      obj_sleep_count[j]=obj_sleep_count[j]-1;
     }
    }     

 }


void Object_Render_Stage2()//Взаимодействие объектов типа obj=1,2 с колобком
 {
  if (p_true==true)//Если колобок существует
   {
    for(j=0; j < obj_num_max; j++)  
     {
      //1. объект на колобке не проваливается
      if (obj_dead[j]==false and //если объект жив
          obj_move[j]==false and
          obj_move_down_v[j]==true and
          obj_sleep_count[j]==0 and
          obj[j].texture>0 and //бонусы или бомбы
          obj[j].texture<=2 and
          obj[j].x==p_x and
          obj[j].y==p_y-1 and
          obj_matrix[p_x][p_y-1]>0)//в этой клетке действительно есть объект
       {
        obj_move_down_v[j]=false;
       }
 
      //2. объект не катится влево на колобка если под колобком яма 
      if (obj_dead[j]==false and //если объект жив
          obj_move[j]==false and
          obj_move_left_v[j]==true and
          obj[j].texture>0 and //бонусы или бомбы
          obj[j].texture<=2 and
          obj[j].x==p_x+1 and
          obj[j].y==p_y and
          obj_matrix[p_x+1][p_y]>0)//в этой клетке действительно есть объект
       {
        obj_move_left_v[j]=false;
       }

      //3. объект не катится влево на колобка если под колобком яма 
      if (obj_dead[j]==false and //если объект жив
          obj_move[j]==false and
          obj_move_right_v[j]==true and
          obj[j].texture>0 and //бонусы или бомбы
          obj[j].texture<=2 and
          obj[j].x==p_x-1 and
          obj[j].y==p_y and
          obj_matrix[p_x-1][p_y]>0)//в этой клетке действительно есть объект
       {
        obj_move_right_v[j]=false;
       }

      //4. объект не катится влево на колобка если он в яме 
      if (obj_dead[j]==false and //если объект жив
          obj_move[j]==false and
          obj_move_left_v[j]==true and
          obj_move_down_left_v[j]==true and
          obj[j].texture>0 and //бонусы или шарики
          obj[j].texture<=2 and
          obj[j].x==p_x+1 and
          obj[j].y==p_y-1 and
          obj_matrix[p_x+1][p_y-1]>0)//в этой клетке действительно есть объект
       {
        obj_move_left_v[j]=false;
        obj_move_down_left_v[j]=false;
       }

      //5. объект не катится вправо на колобка если он в яме
      if (obj_dead[j]==false and //если объект жив
          obj_move[j]==false and
          obj_move_right_v[j]==true and
          obj_move_down_right_v[j]==true and
          obj[j].texture>0 and //бонусы или шарики
          obj[j].texture<=2 and
          obj[j].x==p_x-1 and
          obj[j].y==p_y-1 and
          obj_matrix[p_x-1][p_y-1]>0)//в этой клетке действительно есть объект
       {
        obj_move_right_v[j]=false;
        obj_move_down_right_v[j]=false;
       }

     }//конец цикла
   }//конец условия "Если колобок существует"
 }

void Object_Render_Stage3()//Старт движения и псевдо АИ(поведение) объектов
 { 
  for(j=0; j < obj_num_max; j++)
   {
    //для obj=1,2-бонусы и бомбы
    if (obj_dead[j]==false and //если объект жив
        obj_matrix[obj[j].x][obj[j].y]==1 or
        obj_dead[j]==false and //если объект жив
        obj_matrix[obj[j].x][obj[j].y]==2)
     {
      //1. падение вниз
      if (obj_move[j]==false and
          obj_move_down[j]==false and
          obj_move_down_v[j]==true)
       {
        obj_move[j]=true;
        obj_move_down[j]=true;
        obj_move_down_v[j]=false;
        //на время движения новая клетка заранее занимается
        obj_matrix[obj[j].x][obj[j].y+1]=obj_matrix[obj[j].x][obj[j].y];  
       }

      //2. влево, затем падение вниз
      if (obj_move[j]==false and
          obj_move_left[j]==false and
          obj_move_left_v[j]==true and
          obj_move_down_left_v[j]==true)
       {
        obj_move[j]=true;
        obj_move_left[j]=true;
        obj_rotate[j]=1;//крутится при движении
        obj_move_left_v[j]=false;
        obj_move_down_left_v[j]=false;
        //на время движения новая клетка заранее занимается
        obj_matrix[obj[j].x-1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];  
       }

      //3. вправо, затем падение вниз
      if (obj_move[j]==false and
          obj_move_right[j]==false and
          obj_move_right_v[j]==true and
          obj_move_down_right_v[j]==true)
       {
        obj_move[j]=true;
        obj_move_right[j]=true;
        obj_rotate[j]=1;//крутится при движении 
        obj_move_right_v[j]=false;
        obj_move_down_right_v[j]=false;
        //на время движения новая клетка заранее занимается
        obj_matrix[obj[j].x+1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];
       }

     }//конец условия 
    
    //для obj=3-вихрь
    if (obj_dead[j]==false and //если объект жив
        obj_matrix[obj[j].x][obj[j].y]==3)
     {

      //определяем направление движения-псевдо АИ 
      if (obj_move[j]==false) 
       {
        obj_AI_rnd[j]=rand()%4+1;//определяем случайно куда двинутся случайно
        obj_rotate[j]=2;//все время крутится
       }

      //1. вверх
      if (obj_move[j]==false and
          obj_AI_rnd[j]==1 and 
          obj_move_up[j]==false and
          obj_move_up_v[j]==true) 
       {
        obj_move[j]=true;
        obj_move_up[j]=true;
        obj_move_up_v[j]=false;
        //на время движения новая клетка заранее занимается
        obj_matrix[obj[j].x][obj[j].y-1]=obj_matrix[obj[j].x][obj[j].y];  
       } 
    
      //2. вниз
      if (obj_move[j]==false and
          obj_AI_rnd[j]==2 and 
          obj_move_down[j]==false and
          obj_move_down_v[j]==true) 
       {
        obj_move[j]=true;
        obj_move_down[j]=true;
        obj_move_down_v[j]=false;
        //на время движения новая клетка заранее занимается
        obj_matrix[obj[j].x][obj[j].y+1]=obj_matrix[obj[j].x][obj[j].y];
       }          
       
      //3. влево
      if (obj_move[j]==false and
          obj_AI_rnd[j]==3 and 
          obj_move_left[j]==false and
          obj_move_left_v[j]==true) 
       {
        obj_move[j]=true;
        obj_move_left[j]=true;
        obj_move_left_v[j]=false;
        //на время движения новая клетка заранее занимается
        obj_matrix[obj[j].x-1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];
       }         

      //4. вправо 
      if (obj_move[j]==false and
          obj_AI_rnd[j]==4 and 
          obj_move_right[j]==false and
          obj_move_right_v[j]==true) 
       {
        obj_move[j]=true;
        obj_move_right[j]=true;
        obj_move_right_v[j]=false;
        //на время движения новая клетка заранее занимается
        obj_matrix[obj[j].x+1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];
       }         

     }//конец условия 

   }//конец цикла

 }

void Object_Render_Stage4()//Анимация и движение объектов
 {
  for(j=0; j < obj_num_max; j++)
   {
    //для obj
    if (obj_dead[j]==false and //если объект жив
        obj_matrix[obj[j].x][obj[j].y]>0) 
     {
      //1. полет вверх
      if (obj_move_up[j]==true and
          obj_move[j]==true)
       {
        obj_move_y[j]=obj_move_y[j]-(grid/32)*100/fps;//скорость продвижения между клетками
        if (obj_move_y[j]<-grid) //окончание передвижения
         {
          obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
          obj[j].y=obj[j].y-1;//после передвижения передвигаемся на новую клетку физически
          obj_move_y[j]=0;
          obj_move_up[j]=false;
          obj_move[j]=false;
         }
       }

      //2. падение вниз
      if (obj_move_down[j]==true and
          obj_move[j]==true)
       {
        obj_move_y[j]=obj_move_y[j]+(grid/32)*100/fps;//скорость продвижения между клетками
        if (obj_move_y[j]>grid) //окончание передвижения
         {
          obj_sleep_count[j]=5;
          obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
          obj[j].y=obj[j].y+1;//после передвижения передвигаемся на новую клетку физически
          obj_move_y[j]=0;
          obj_move_down[j]=false;
          obj_move[j]=false;
         }
       } 

      //3. влево
      if (obj_move_left[j]==true and
          obj_move[j]==true)
       {
        obj_move_x[j]=obj_move_x[j]-(0.15*grid);//скорость продвижения между клетками

        if (obj_rotate[j]==1)//крутится при движении
         {
          obj_delta[j]=obj_delta[j]+(360/grid)*(0.15*grid);//объект катится
         }
 
        if (obj_move_x[j]<-grid) //окончание передвижения
         {
          obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
          obj[j].x=obj[j].x-1;//после передвижения передвигаемся на новую клетку физически
          obj_move_x[j]=0;
          obj_move_left[j]=false;
          obj_move[j]=false;
            
          if (obj_rotate[j]==1) //если объект катиться
           {
            if (obj_delta[j]>360) {obj_delta[j]=0;}
            obj_rotate[j]=0;//больше не катиться
           }
         }
       }//конец влево

      //4. вправо
      if (obj_move_right[j]==true and
          obj_move[j]==true)
       {
        obj_move_x[j]=obj_move_x[j]+(0.15*grid);//скорость продвижения между клетками

        if (obj_rotate[j]==1)//крутится при движении
         {
          obj_delta[j]=obj_delta[j]-(360/grid)*(0.15*grid);//объект катится
         }

        if (obj_move_x[j]>grid)//окончание передвижения
         {
          obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
          obj[j].x=obj[j].x+1;//после передвижения передвигаемся на новую клетку физически
          obj_move_x[j]=0;
          obj_move_right[j]=false;
          obj_move[j]=false;

          if (obj_rotate[j]==1) //если объект катиться
           {
            if (obj_delta[j]<-360) {obj_delta[j]=0;}
            obj_rotate[j]=0;//больше не катиться 
           }
         }
       }//конец вправо
      
     }//конец условия 
   }//конец цикла

 }

void Player_Render_Dead()//Столкновение колобка с бомбой и вихрем
 {
  for (j=0;j<obj_num_max;j++)   
  for (k=0;k<eff_num_max;k++)//для начального условие для взрыва
   { 
    if (p_true==true and//столкновение с бомбой-шариком может задавить как сверху так и вообще
        obj_dead[j]==false and //если объект существует
        obj_move[j]==true and //если объект движется
        obj[j].texture==2 and //Если бомба падает на бошку колобку то тратим его жизни
        p_x*grid+p_move_x-0.5*grid<obj[j].x*grid+obj_move_x[j]+0.5*grid and
        p_x*grid+p_move_x+0.5*grid>obj[j].x*grid+obj_move_x[j]-0.5*grid and
        p_y*grid+p_move_y-0.5*grid<obj[j].y*grid+obj_move_y[j]+0.5*grid and
        p_y*grid+p_move_y+0.5*grid>obj[j].y*grid+obj_move_y[j]-0.5*grid and
        eff_true[k]==false//если есть незанятый эффект
      
        or 
 
        p_true==true and //столкновение с вихрем
        obj_dead[j]==false and
        obj[j].texture==3 and
        p_x*grid+p_move_x-0.5*grid<obj[j].x*grid+obj_move_x[j]+0.5*grid and
        p_x*grid+p_move_x+0.5*grid>obj[j].x*grid+obj_move_x[j]-0.5*grid and
        p_y*grid+p_move_y-0.5*grid<obj[j].y*grid+obj_move_y[j]+0.5*grid and
        p_y*grid+p_move_y+0.5*grid>obj[j].y*grid+obj_move_y[j]-0.5*grid and
        eff_true[k]==false)
     {
      //начальные условия для эффектов
      eff_true[k]=true;
      eff_type[k]=1;//тип эффекта-взрыв
      eff_W[k]=2*rand()%grid+2*grid;//размеры эффекта
      eff_H[k]=eff_W[k];
      eff_cR[k]=1;//оттенки цвета эффекта R,G,B
      eff_cG[k]=1;
      eff_cB[k]=1;
      eff_cAlpha[k]=1;//прозрачность эффетка
   
      eff_counter[k]=1;//таймер эффекта=кадр
      eff_x[k]=p_x*grid+(rand()%45+1)-(rand()%45+1);//местоположение эффекта
      eff_y[k]=p_y*grid+(rand()%45+1)-(rand()%45+1);

      //отнимаем у колобка жизнь 
      p_live=p_live-1;
      if (p_live==0)//если жизнь кончилвсь, то колобок сдох
       {
        p_live=0; 
        p_true=false;//колобок больше не существует - не жилец:(
       }
 
      break; 
     }//выход из условия "столкновения"
 
   }//конец циклов

 }

void PlayerEatObject()//Колобок ест бонусы (obj=1) и собирает при этом очки
 {
  for(j=0; j < obj_num_max; j++) 
   {
    if (p_true==true and //если колобок и объект существуют
        obj_dead[j]==false and
        obj[j].texture==1 and 
        p_x*grid+p_move_x-0.33*grid<obj[j].x*grid+obj_move_x[j]+0.33*grid and
        p_x*grid+p_move_x+0.33*grid>obj[j].x*grid+obj_move_x[j]-0.33*grid and
        p_y*grid+p_move_y-0.33*grid<obj[j].y*grid+obj_move_y[j]+0.33*grid and
        p_y*grid+p_move_y+0.33*grid>obj[j].y*grid+obj_move_y[j]-0.33*grid)
     {
      obj_matrix[p_x][p_y]=0;//стираем объект из матрицы объектов
      obj_matrix[obj[j].x][obj[j].y]=0; 

      //если объект двигался
      if (obj_move[j]==true)
       {
        if (obj_move_up[j]==true) {obj_matrix[obj[j].x][obj[j].y-1]=0;}
        if (obj_move_down[j]==true) {obj_matrix[obj[j].x][obj[j].y+1]=0;}
        if (obj_move_left[j]==true) {obj_matrix[obj[j].x][obj[j].y-1]=0;}
        if (obj_move_right[j]==true) {obj_matrix[obj[j].x][obj[j].y+1]=0;}
       }

      obj_dead[j]=true;//объект мертв
      p_score=p_score+1;//начисляем очки за поедание
     }//конец условия
   }//конец цикла

 }

void Object_Render_Dead()//Смерть объектов
 {
  //если объект умер(подобран) там эффект
  for (j=0;j<obj_num_max;j++)   
  for (k=0;k<eff_num_max;k++)//начальные условие
   { 
    //молния-когда подобрали молекулы obj=1
    if (obj[j].texture==1 and
        obj_dead[j]==true and//если объект умер
        eff_true[k]==false) 
     {
      obj_dead[j]=false;//объекта больше не существует

      eff_true[k]=true;//параметры эффетка
      eff_type[k]=2;//молния
      eff_W[k]=2*rand()%grid+2*grid;
      eff_H[k]=eff_W[k];
      eff_cR[k]=1;
      eff_cG[k]=1;
      eff_cB[k]=1;
      eff_cAlpha[k]=1;  

      eff_counter[k]=1;
      eff_x[k]=obj[j].x*grid+obj_move_x[j];
      eff_y[k]=obj[j].y*grid+obj_move_y[j];
   
      obj[j].x=0;//объекта больше нет
      obj[j].y=0;//координаты обнуляем только сейчас, т.к. они нужны были для эффекта
      obj[j].texture=0;

     }//конец условия

    //как дохнут бомбы или вихри obj=2,3
    if (obj[j].texture==2 and //бомбы
        obj_dead[j]==true and
        eff_true[k]==false or

        obj[j].texture==3 and //вихри
        obj_dead[j]==true and
        eff_true[k]==false) 
     {
      obj_dead[j]=false;//объекта больше не существует

      eff_true[k]=true;
      eff_type[k]=1;//взрыв
      eff_W[k]=5*rand()%grid+5*grid;
      eff_H[k]=eff_W[k];
      eff_cR[k]=1;
      eff_cG[k]=1;
      eff_cB[k]=1;
      eff_cAlpha[k]=1;  
   
      eff_counter[k]=1;
      eff_x[k]=obj[j].x*grid+obj_move_x[j];
      eff_y[k]=obj[j].y*grid+obj_move_y[j];
   
      obj[j].x=0;
      obj[j].y=0;
      obj[j].texture=0;
     }//конец условия
   }//конец циклов 

  //при взрыве бомбы или вихря повреждаем соседей
  for(j=0; j < obj_num_max; j++)
   {
    if (obj_dead[j]==false and //объект до взрыва жив
        obj_move[j]==false and //обездвижен-для снятия артефактов с матрицы
        obj_nuke[j]==true) //объект на подрыве
     {
      obj_nuke_count[j]=obj_nuke_count[j]+1;//таймер до взрыва 
      if (obj_nuke_count[j]>20+rand()%10)//если объект взорвался
       {
        obj_nuke[j]=false;
        obj_nuke_count[j]=0;
        obj_matrix[obj[j].x][obj[j].y]=0;//стираем объект из матрицы объектов
        obj_dead[j]=true;//объект мертв

        //1.подрываем бомбы и вихри в округе
        for( k=0; k < obj_num_max; k++)
         {      
          if (obj_dead[k]==false and//бомбы в спокойном состоянии
              obj[k].texture==2 and
              obj_sleep_count[k]==0 or
 
              obj[k].texture==3 and//вихри
              obj_dead[k]==false) 
           {   
            //радиус взрыва по 8 направлениям по часовой
            //812
            //703
            //654

            //1
            if (obj[k].x==obj[j].x and
                obj[k].y==obj[j].y-1 and
                obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                obj_nuke[k]==false)
             {
              obj_nuke[k]=true;
              obj_nuke_count[k]=0;
             } 

            //2
            if (obj[k].x==obj[j].x+1 and
                obj[k].y==obj[j].y-1 and
                obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                obj_nuke[k]==false)
             {
              obj_nuke[k]=true;
              obj_nuke_count[k]=0;
             } 

            //3
            if (obj[k].x==obj[j].x+1 and
                obj[k].y==obj[j].y and
                obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                obj_nuke[k]==false)
             {
              obj_nuke[k]=true;
              obj_nuke_count[k]=0;
             } 

            //4
            if (obj[k].x==obj[j].x+1 and
                  obj[k].y==obj[j].y+1 and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 

            //5
            if (obj[k].x==obj[j].x and
                obj[k].y==obj[j].y+1 and
                obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                obj_nuke[k]==false)
             {
              obj_nuke[k]=true;
              obj_nuke_count[k]=0;
             } 

            //6
            if (obj[k].x==obj[j].x-1 and
                obj[k].y==obj[j].y+1 and
                obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                obj_nuke[k]==false)
             {
              obj_nuke[k]=true;
              obj_nuke_count[k]=0;
             } 

            //7
            if (obj[k].x==obj[j].x-1 and
                obj[k].y==obj[j].y and
                obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                obj_nuke[k]==false)
             {
              obj_nuke[k]=true;
              obj_nuke_count[k]=0;
             } 

            //8
            if (obj[k].x==obj[j].x-1 and
                obj[k].y==obj[j].y-1 and
                obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                obj_nuke[k]==false)
             {
              obj_nuke[k]=true;
              obj_nuke_count[k]=0;
             }
           
           }//конец условия
         }//конец цикла k 

        //2.подрываем процессоры-элементы уровня
        for(l=0;l<lev_num_max;l++) 
         {
          if (lev[l].texture==6 or
              lev[l].texture==7)
           {  
            //радиус взрыва по 8 направлениям по часовой
            //812
            //703
            //654   

            //1
            if (lev[l].x==obj[j].x and 
                lev[l].y==obj[j].y-1 and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture or
            //2
                lev[l].x==obj[j].x+1 and 
                lev[l].y==obj[j].y-1 and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture or
            //3 
                lev[l].x==obj[j].x+1 and 
                lev[l].y==obj[j].y and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture or
            //4  
                lev[l].x==obj[j].x+1 and 
                lev[l].y==obj[j].y+1 and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture or
            //5 
                lev[l].x==obj[j].x and 
                lev[l].y==obj[j].y+1 and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture or
            //6
                lev[l].x==obj[j].x-1 and 
                lev[l].y==obj[j].y+1 and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture or
            //7
                lev[l].x==obj[j].x-1 and 
                lev[l].y==obj[j].y and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture or
            //8
                lev[l].x==obj[j].x-1 and 
                lev[l].y==obj[j].y-1 and
                lev_matrix[lev[l].x][lev[l].y]==lev[l].texture)
             {
              lev_matrix[lev[l].x][lev[l].y]=0;//стираем элемент уровня
              lev[l].x=0;
              lev[l].y=0;
              lev[l].texture=0;
             }

           }//конец условия  
         }//конец цикла l
      
       }//конец условия "если объект взорвался"
 
     }//конец условия "объект до взрыва жив"  
   }//коне цикла j

 }


void Level_Draw()//Рисуем уровень
 { 
  for(i=0; i < lev_num_max; i++) 
   {
    //рисуем кал(нули) после того как lev=1
    //если элемент уровня существует и попадает в окно вывода-его рисуем
    if (lev[i].texture==0 and
        p_kal[i]==true and//если это кал 
        lev[i].x*grid+x_cam>0-grid and
        lev[i].x*grid+x_cam<win_DX+grid and 
        lev[i].y*grid+y_cam>0-grid and
        lev[i].y*grid+y_cam<win_DY+grid) 
     {
      glBindTexture(GL_TEXTURE_2D,other_texture[1]);
      DrawTXT (lev[i].x*grid+x_cam,
               lev[i].y*grid+y_cam,
               grid,grid,0,1);  
     }
    //Рисуем уровень
    if (lev[i].texture>0 and
        lev[i].x*grid+x_cam>0-grid and
        lev[i].x*grid+x_cam<win_DX+grid and 
        lev[i].y*grid+y_cam>0-grid and
        lev[i].y*grid+y_cam<win_DY+grid) 
     {
      glBindTexture(GL_TEXTURE_2D,lev_texture[lev[i].texture]);
      DrawTXT (lev[i].x*grid+x_cam,
               lev[i].y*grid+y_cam,
               grid,grid,0,1);  

      //если дверь на выход, то на ней выводим количество очков для выхода из уровня
      if (lev[i].texture==2 or lev[i].texture==3)
       {
        if (lev[i].texture==2) {sprintf(txt_tmp,"%i",lev[i].exit_score);}//количество очков на выход
        if (lev[i].texture==3) {sprintf(txt_tmp,"%i",lev[i].exit_kills);}
        GlTxt(grid,//32,
              grid,//16,
              fonts[2],txtColorWhite,txt_tmp, t_txt[4]);
        glColor4f(0,
                  0,
                  0,
                  0.5+0.01*(rand()%50+1));
        glBindTexture(GL_TEXTURE_2D,t_txt[4]);
        DrawTXT (lev[i].x*grid+0.35*grid+x_cam,
                 lev[i].y*grid+y_cam,
                 grid,
                 grid,
                 0,1); 
        glColor4f(1,1,1,1);
       }

     }//конец условия
   }//конец цикла i

 }


void Portals_Draw()//Рисуем телепорты
 { 
  delta=delta+5;//кручение 
  if (delta>360) {delta=0;}  

  //вход 
  if (t1_true==true)
   {
    glBindTexture(GL_TEXTURE_2D,t_texture);
    glColor4f(1,1,1,1);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    DrawTXT(t1x*grid+x_cam,
            t1y*grid+y_cam,
            0.9*grid-3*sin(delta*3.142/180),
            0.9*grid-3*sin(delta*3.142/180),delta+240,1); 
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glColor4f(0.5,0.5,0,1);
    DrawTXT(t1x*grid+x_cam,
            t1y*grid+y_cam,
            0.9*grid-6*sin(delta*3.142/180),
            0.9*grid-6*sin(delta*3.142/180),2*delta+120,1);
    glColor4f(1,0,0,1);
    DrawTXT(t1x*grid+x_cam,
            t1y*grid+y_cam,
            0.9*grid+9*sin(delta*3.142/180),
            0.9*grid+9*sin(delta*3.142/180),delta,1);  
    glColor4f(1,1,1,1);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);  
   }

  //выход
  if (t2_true==true)
   {
    glBindTexture(GL_TEXTURE_2D,t_texture);
    glColor4f(1,1,1,1);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    DrawTXT(t2x*grid+x_cam,
            t2y*grid+y_cam,
            0.9*grid-3*sin(delta*3.142/180),
            0.9*grid-3*sin(delta*3.142/180),-delta-240,1); 
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glColor4f(0,0,1,1);
    DrawTXT(t2x*grid+x_cam,
            t2y*grid+y_cam,
            0.9*grid-6*sin(delta*3.142/180),
            0.9*grid-6*sin(delta*3.142/180),-2*delta-120,1);
    glColor4f(0,1,0,1);
    DrawTXT(t2x*grid+x_cam,
            t2y*grid+y_cam,
            0.9*grid+9*sin(delta*3.142/180),
            0.9*grid+9*sin(delta*3.142/180),-delta,1);  
    glColor4f(1,1,1,1);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA); 
   }
 }

void Object_Draw()//Рисуем объекты
 {
  for(j=0; j < obj_num_max; j++) 
   {
    //если элемент уровня существует(жив) и попадает в окно вывода-выводим его
    if (obj_dead[j]==false and 
        obj[j].texture>0 and
        obj[j].x*grid+x_cam>0-grid and
        obj[j].x*grid+x_cam<win_DX+grid and 
        obj[j].y*grid+y_cam>0-grid and
        obj[j].y*grid+y_cam<win_DY+grid) 
     {
      if (obj_rotate[j]==2)//если объект крутится все время
       {
        obj_delta[j]=obj_delta[j]+(360/grid)*100/fps;//объект катится
        if (obj_delta[j]>360) {obj_delta[j]=0;}
       }

      glBindTexture(GL_TEXTURE_2D,obj_texture[obj[j].texture]);
      DrawTXT(obj[j].x*grid+obj_move_x[j]+x_cam,
              obj[j].y*grid+obj_move_y[j]+y_cam,
              grid+obj_nuke_count[j],
              grid+obj_nuke_count[j],
              obj_delta[j],1); 
     }//конец условия
   }//конец цикла j

  /*
  //сетка для проверки матрицы объектов 
  for(j=0;j<lev_width+1;j++)
  for(k=0;k<lev_height+1;k++)
   {
    if (obj_matrix[j][k]==0)
     {
      glBindTexture(GL_TEXTURE_2D,obj_texture[5]);
      DrawTXT(j*32+x_cam,
              k*32+y_cam,20,20,0,1); 
     }
   }
  */

 }

void Player_Draw()//Рисуем колобка
 {
  if (p_true==true)//если колобок жив
   {
    glBindTexture(GL_TEXTURE_2D,player_texture[p_frame]);
    DrawTXT(p_x*grid+p_move_x+x_cam,
            p_y*grid+p_move_y+y_cam,
            grid,grid,0,1); 
   }  
 }

void Effect_Draw()//Рисуем эффекты
 {  
  for(i=0;i<eff_num_max;i++)
   {
    if (eff_true[i]==true)
     {
      eff_counter[i]=eff_counter[i]+1;//счетчик кадров
      if (eff_counter[i]==20 and//20 кадров взрыва
          eff_type[i]==1) {eff_true[i]=false;} 
      if (eff_counter[i]==16 and//16 кадров молнии
          eff_type[i]==2) {eff_true[i]=false;} 

      glBlendFunc(GL_SRC_ALPHA,GL_ONE);
      glColor4f(eff_cR[i], eff_cG[i],eff_cB[i],eff_cAlpha[i]);
      glBindTexture(GL_TEXTURE_2D,eff_texture[eff_type[i]][eff_counter[i]]);
      DrawTXT(eff_x[i]+x_cam,
              eff_y[i]+y_cam,
              eff_W[i],
              eff_H[i],0,1); 
      glColor4f(1,1,1,1);
      glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
     }//конец условия 
   }//конец цикла i
 }

void HUD_Draw()//Рисуем ХУД
 {
  //ХУД
  glBindTexture(GL_TEXTURE_2D,other_texture[3]);
  DrawTXT(0,0,512,64,0,0); 

  //значок молекулы
  glBindTexture(GL_TEXTURE_2D,obj_texture[1]);
  DrawTXT(27,25,20,20,0,1);

  //лайв бар
  if (p_live>0)
   {     
    glBindTexture(GL_TEXTURE_2D,other_texture[2]);
    DrawTXT(45,
            28,
            p_live*10,
            20,0,0); 
   } 


  //выводим число очков    
  sprintf(txt_tmp,"%i",p_score);
  GlTxt(50,16,fonts[2],txtColorWhite,txt_tmp,t_txt[1]);
  glBindTexture(GL_TEXTURE_2D,t_txt[1]);
  DrawTXT(16,36,50,16,0,0);

  //выводим номер уровня
  sprintf(txt_tmp,"level:%i",num_level);//номер уровня
  GlTxt(140,16,fonts[2],txtColorWhite,txt_tmp,t_txt[3]);
  glBindTexture(GL_TEXTURE_2D,t_txt[3]);
  DrawTXT(45,10,140,16,0,0);

 }    



//============
//=[РЕДАКТОР]=-процедуры
//============

int edit_mode,//режим редактирования
    score_for_exit,//очки выхода
    num_texture,//порядковый номер текстуры
    x_cursor,
    y_cursor;    

GLuint cursor_texture;//текстура курсора для редактора 

void Edit_Init()//клавиши управления редактором
 {

  InitGame();
  Load_Game_Textures();

  //Текстура курсора
  load("data/img/other/cursor.png", cursor_texture);

  num_level=1;//начинаем с первого уровня
  score_for_exit=0;
  edit_mode=1;
  num_texture=1;

  x_cursor=1;
  y_cursor=1;

//  x_cam=100;
//  y_cam=100;
 }
 
void Edit_Controls()//клавиши управления редактором
 {
//управление курсором
  if (event.key.keysym.sym==SDLK_UP) {y_cursor=y_cursor-1;} 
  if (event.key.keysym.sym==SDLK_DOWN) {y_cursor=y_cursor+1;} 
  if (event.key.keysym.sym==SDLK_LEFT) {x_cursor=x_cursor-1;} 
  if (event.key.keysym.sym==SDLK_RIGHT) {x_cursor=x_cursor+1;}

//ограничение передвижения курсора по уровню
  if (x_cursor>=lev_width) {x_cursor=lev_width;} 
  if (x_cursor<=0) {x_cursor=0;}  
  if (y_cursor>=lev_height) {y_cursor=lev_height;} 
  if (y_cursor<=0) {y_cursor=0;}    

//переключение элементов уровня 
  if (event.key.keysym.sym==SDLK_q) {num_texture=num_texture+1;}
  if (event.key.keysym.sym==SDLK_e) {num_texture=num_texture-1;}

//прокручивание очков выхода 
  if (event.key.keysym.sym==SDLK_z) {score_for_exit=score_for_exit+1;}
  if (event.key.keysym.sym==SDLK_x) {score_for_exit=score_for_exit-1;}

//переключение номера уровня 
  if (event.key.keysym.sym==SDLK_c) {num_level=num_level+1;}
  if (event.key.keysym.sym==SDLK_v) {num_level=num_level-1;}

//происходит переключение режимов редактора
  if (event.key.keysym.sym==SDLK_F1) {edit_mode=1;}//статичные lev
  if (event.key.keysym.sym==SDLK_F2) {edit_mode=2;}//динамические obj

//устанавливаем элемент
  if (event.key.keysym.sym==SDLK_SPACE) 
   {
    if (edit_mode==1)//статичные lev
     {  
      for(i=0;i<lev_num_max;i++) 
       {
        if (lev[i].texture==0 and 
            lev_matrix[x_cursor][y_cursor]==0) 
         {
          lev[i].x=x_cursor;
          lev[i].y=y_cursor;
          lev[i].texture=num_texture;

          if (lev[i].texture==2) {lev[i].exit_score=score_for_exit;}//выход
          if (lev[i].texture==3) {lev[i].exit_kills=score_for_exit;}//выход

          break;
         }
       }
     }
    if (edit_mode==2)//динамические obj
     {  
      for(j=0; j < obj_num_max; j++) 
       {
        if (obj[j].texture==0 and 
            obj_matrix[x_cursor][y_cursor]==0) 
         {
          obj[j].x=x_cursor;
          obj[j].y=y_cursor;
          obj[j].texture=num_texture;
          break;
         }
       }
     }

   }//конец "устанавливаем элемент"

//стираем элемент
  if ( event.key.keysym.sym == SDLK_DELETE )
   { 
    if (edit_mode==1)//статичные lev
     {     
      for(i=0; i < lev_num_max; i++) 
       {
        if (lev[i].texture>0 and lev[i].x==x_cursor and lev[i].y==y_cursor and
            lev_matrix[x_cursor][y_cursor]==lev[i].texture) 
         {
          lev_matrix[x_cursor][y_cursor]=0;
          lev[i].exit_score=0;
          lev[i].exit_kills=0;
          lev[i].x=0;
          lev[i].y=0;
          lev[i].texture=0;
          break;
         }
       }
     }

    if (edit_mode==2)//динамические obj
     {     
      for(j=0; j < obj_num_max; j++) 
       {
        if (obj[j].texture>0 and obj[j].x==x_cursor and obj[j].y==y_cursor and
            obj_matrix[x_cursor][y_cursor]==obj[j].texture) 
         {
          obj_matrix[x_cursor][y_cursor]=0;
          obj[j].x=0;
          obj[j].y=0;
          obj[j].texture=0;
                    
          //чтобы не крутилось
          obj_rotate[j]=0;
          obj_delta[j]=0;
 
          break;
         }
       }
     }
   }//конец "стираем элемент"
 
//сохранение уровня
  if ( event.key.keysym.sym == SDLK_F5 )
   { 
    sprintf(buff,"data/map/lev%i.dat",num_level);
    fp=fopen(buff,"w");//статичные lev
    fwrite((char *)lev, sizeof(struct lev_type), lev_num_max, fp);
    fclose (fp); 

    sprintf(buff,"data/map/obj%i.dat",num_level);
    fp=fopen(buff,"w");//динамические obj
    fwrite((char *)obj, sizeof(struct obj_type), obj_num_max, fp);
    fclose (fp); 
   } 

//загрузка уровня
  if ( event.key.keysym.sym == SDLK_F7 )
   { 
    InitGame();
/*
    sprintf(buff,"data/map/lev%i.dat",num_level);
    fp=fopen(buff,"r");
    fread((char *)lev, sizeof(struct lev_type), lev_num_max, fp);
    fclose (fp); 

    sprintf(buff,"data/map/obj%i.dat",num_level);
    fp=fopen(buff,"r");
    fread((char *)obj, sizeof(struct obj_type), obj_num_max, fp);
    fclose (fp);
*/
    Load_Level(num_level);

   }
 
 }

void Cam_Controls_KeyDown()//управление камерой с клавиатуры
 {
  //управление камерой
  if ( keys[SDLK_w] ) {y_cam=y_cam+3;} 
  if ( keys[SDLK_s] ) {y_cam=y_cam-3;} 
  if ( keys[SDLK_a] ) {x_cam=x_cam+3;} 
  if ( keys[SDLK_d] ) {x_cam=x_cam-3;}

  //перемещение игрового экрана-камеры
  if ((x_cursor*grid+x_cam)>(win_DX-7*grid)) {x_cam=x_cam-0.1*grid;}//смещение на 0.1 от grid
  if ((x_cursor*grid+x_cam)<(0+7*grid)) {x_cam=x_cam+0.1*grid;}
  if ((y_cursor*grid+y_cam)>(win_DY-4*grid)) {y_cam=y_cam-0.1*grid;}
  if ((y_cursor*grid+y_cam)<(0+4*grid)) {y_cam=y_cam+0.1*grid;}

 }

void Cursor_Draw()//Рисуем курсор редактора 
 {
  delta=delta+5;
  if (delta>360) {delta=0;}  

  if (edit_mode==1) {glBindTexture( GL_TEXTURE_2D, lev_texture[num_texture] );}
  if (edit_mode==2) {glBindTexture( GL_TEXTURE_2D, obj_texture[num_texture] );}

  DrawTXT (x_cursor*grid+x_cam,
           y_cursor*grid+y_cam,
           grid,grid,0,1);
  
  glBindTexture( GL_TEXTURE_2D, cursor_texture );
  DrawTXT (x_cursor*grid+x_cam,
           y_cursor*grid+y_cam,
           grid+5*sin(delta*3.142/180),
           grid+5*sin(delta*3.142/180),delta,1);  

 }

void Other_Draw()//вывод прочего 
 {
  //ХУД
  glBindTexture(GL_TEXTURE_2D,other_texture[3]);
  DrawTXT(0,0,512,64,0,0); 

/*
  //значок молекулы
  glBindTexture(GL_TEXTURE_2D,obj_texture[1]);
  DrawTXT(27,25,20,20,0,1);

  //количество очков на выход
  sprintf(txt_tmp,"%i",exit_score);
  GlTxt(16,16,fonts[1],txtColorWhite,txt_tmp, t_txt[2]);
  glBindTexture( GL_TEXTURE_2D, t_txt[2] );
  DrawTXT(28,45,16,16,0,1);
*/

  //выводим номер уровня
  sprintf(txt_tmp,"c/v:level:%i",num_level);//номер уровня
  GlTxt(200,16,fonts[2],txtColorWhite,txt_tmp, t_txt[3]);
  glBindTexture( GL_TEXTURE_2D, t_txt[3] );
  DrawTXT(45,10,200,16,0,0);

  //выводим режим редактора
  sprintf(txt_tmp,"f1,f2:e-mode:%i",edit_mode);
  GlTxt(200,16,fonts[2],txtColorWhite,txt_tmp, t_txt[4]);
  glBindTexture( GL_TEXTURE_2D, t_txt[4] );
  DrawTXT(45,25,200,16,0,0);

  //выводим номер элемента
  sprintf(txt_tmp,"q/e:elemn:%i",num_texture);
  GlTxt(200,16,fonts[2],txtColorWhite,txt_tmp, t_txt[5]);
  glBindTexture( GL_TEXTURE_2D, t_txt[5] );
  DrawTXT(45,40,200,16,0,0);

  //выводим количество очков на выход
  sprintf(txt_tmp,"z/x:e-scr:%i",score_for_exit);
  GlTxt(200,16,fonts[2],txtColorWhite,txt_tmp, t_txt[6]);
  glBindTexture( GL_TEXTURE_2D, t_txt[6] );
  DrawTXT(250,10,200,16,0,0);

  //выводим координаты курсора
  sprintf(txt_tmp,"arrows keys:x=%i,y=%i",x_cursor,y_cursor);
  GlTxt(250,16,fonts[2],txtColorWhite,txt_tmp, t_txt[7]);
  glBindTexture( GL_TEXTURE_2D, t_txt[7] );
  DrawTXT(250,25,250,16,0,0);

  //выводим остальные клавиши
  GlTxt(250,16,fonts[2],txtColorWhite,"w,a,s,d,spc,del,f5/f7", t_txt[8]);
  glBindTexture( GL_TEXTURE_2D, t_txt[8] );
  DrawTXT(250,40,250,16,0,0);

 }


