//     
using namespace std;//         string (string.h)

// 
const 
 int button_max=9999;//  

struct button_type//
 { 
  int x,y,dx,dy;//   
  bool cursor_on_button_area,//   
       click_button_area,//   
       on_screen;//    

  char *name;// 
  GLuint texture;// 
         //text_texture;//   
 }
button[button_max];

// 
TTF_Font *fonts[9] = {NULL,NULL,NULL};// 3 
//  
  SDL_Color txtColorRed = {255,1,1};
  SDL_Color txtColorGreen = {1,255,1};
  SDL_Color txtColorBlue = {1,1,255};
  SDL_Color txtColorWhite = {255,255,255};
  SDL_Color txtColorBlack = {1,1,1};
GLuint t_txt[80];//  


//  
float fps,fps_max,fps_timer,timer,now,then;  
float k_fps;//     



int mouse_index;//      
bool mouse_on_button_area;


GLuint panel_cursor_texture,//  
       area_texture[3];//    


void InitFps()// 
 {
  timer=0;
  fps=1;
  fps_max=fps;
 
  k_fps=1;
 }

void SolveFps()// , 
 {
  now = SDL_GetTicks();
  fps_timer=fps_timer+1;
  if ((now-then)>1000 or now<then)
   {
    then = SDL_GetTicks();
    fps=fps_timer;
    if (timer>1 and fps>fps_max) {fps_max=fps;}
    fps_timer=0;
    timer=timer+1;// 
    k_fps=(fps/fps_max);
   } 
 }


float delay_temp;

void Delay_by_Fps(int fps_limit)//    
 {

  if (fps>fps_limit)
     {delay_temp=delay_temp+0.05;}

  SDL_Delay(delay_temp);

 }

// 2 
void gl2dMode (int dW, int dH)
 {
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    glOrtho( 0, dW, dH, 0, -1, 1 );
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
 }

//      
bool load(string file, GLuint &tex)
 {
  SDL_Surface *temp = NULL;
  GLint maxTexSize;
  GLuint glFormat = GL_RGBA;
      
  if(file.substr(file.length()-3,3).compare("jpg") == 0)
   {
    glFormat = GL_RGB;
   }
      
  glGetIntegerv(GL_MAX_TEXTURE_SIZE, &maxTexSize); 

  temp = IMG_Load(file.data());

  if(temp == NULL)
   {
    cout << "Texture manager ERROR: " << file << " : "<< SDL_GetError() << endl;
    SDL_FreeSurface( temp );
    return 0;
   }
      
  if(temp->w > maxTexSize)
   {
    cout << "Texture manager ERROR: " << file << " texturesize too large." << endl;
   }
 
  glGenTextures(1, &tex);
  glBindTexture(GL_TEXTURE_2D, tex);

  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );

  glTexImage2D(GL_TEXTURE_2D, 0, glFormat, temp->w, temp->h, 0, glFormat, GL_UNSIGNED_BYTE, temp->pixels);
  SDL_FreeSurface( temp );

  return 1;
}

//  
void DrawTXT (int x,
              int y,
              int dX,
              int dY,
              int delta,
              int center)
 {
    glLoadIdentity();
    glTranslatef(x,y,0);   
    glRotatef(delta,0,0,-1); 
    if (center==1) {glTranslatef(-dX/2,-dY/2,0);}//  

    glBegin( GL_QUADS );
        //   
        glTexCoord2i(0,0);      glVertex2f( 0, 0 );
        //  
        glTexCoord2i( 0, 1 );   glVertex2f( 0, dY );
        //  
        glTexCoord2i( 1, 1 );   glVertex2f( dX, dY );
        //  
        glTexCoord2i( 1, 0 );   glVertex2f( dX, 0 );
    glEnd();
    glLoadIdentity();
 } 

void TTF_TextInit() // 
 {
  TTF_Init();// 
 
// ,    
  fonts[1] = TTF_OpenFont( "data/ttf/font1.ttf", 12 );// 
  fonts[2] = TTF_OpenFont( "data/ttf/font1.ttf", 16 );// 
  fonts[3] = TTF_OpenFont( "data/ttf/font2.ttf", 32 );//  
  fonts[4] = TTF_OpenFont( "data/ttf/font3.ttf", 32 );// 
  fonts[5] = TTF_OpenFont( "data/ttf/font1.ttf", 32 );// 

//  
  glGenTextures(1, &t_txt[1]);//       
 }








//   -    
void GlTxt(int sdl_dx,int sdl_dy,TTF_Font *font, SDL_Color textColor,const char text[2], GLuint texture)
 {
  SDL_Surface *temp,*tempb;
  int w,h;
  Uint32 rmask, gmask, bmask, amask;
  #if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
  #else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
  #endif

  if(font == NULL)
   { 
    cout << SDL_GetError() << endl;;
    SDL_FreeSurface(temp);
    SDL_FreeSurface(tempb);
   }

  temp = TTF_RenderText_Blended(font, text, textColor);
  SDL_SetAlpha(temp, 0, 0);

  tempb = SDL_CreateRGBSurface(0, sdl_dx, sdl_dy, 32, rmask,gmask,bmask,amask);

  TTF_SizeUTF8(font,text, &w,&h);
  
  SDL_Rect src,dst;
  src.x=0;
  src.y=0;
  src.w=sdl_dx;//w;//  ,    10   
  src.h=sdl_dy;//h;

  dst.x=0;
  dst.y=0;
  dst.w=sdl_dx;//w;
  dst.h=sdl_dy;//h;

  SDL_BlitSurface(temp, &src, tempb, &dst);
  glBindTexture(GL_TEXTURE_2D, texture);
  gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, tempb->w, tempb->h, GL_RGBA, GL_UNSIGNED_BYTE, tempb->pixels);

  SDL_FreeSurface(temp);
  SDL_FreeSurface(tempb);

 }


//==  ==

// 1- 
void InitButton(char button_text[],
                char file_name[],
                int button_index,
                int x,int y,int dx,int dy, 
                bool on_screen)
 {
  button[button_index].name=button_text;
  load(file_name,button[button_index].texture);
  button[button_index].x=x;
  button[button_index].y=y;
  button[button_index].dx=dx;
  button[button_index].dy=dy;
  button[button_index].on_screen=on_screen;
 }

//   
//  
void KeyButton_int(int button_index, 
                     SDL_Event event,
                     float mouse_X,
                     float mouse_Y,
                     int *click,
                     int click_delta, 
                     int click_max)
 { 
  if (button[button_index].on_screen==true)
   {
    if (mouse_X>button[button_index].x-0.5*button[button_index].dx and 
        mouse_X<button[button_index].x+0.5*button[button_index].dx and 
        mouse_Y>button[button_index].y-0.5*button[button_index].dy and
        mouse_Y<button[button_index].y+0.5*button[button_index].dy)
     { 
      button[button_index].cursor_on_button_area=true;
      //  
      if (event.type == SDL_MOUSEBUTTONDOWN and
          event.button.state == SDL_PRESSED)// !!
       {
        if(event.button.button == SDL_BUTTON_LEFT) 
         {
          button[button_index].click_button_area=not button[button_index].click_button_area;//   
        
          *click=*click+click_delta;
          //  
          if (click_delta>0 and
             *click>click_max) {*click=0;}
          //  
          if (click_delta<0 and
             *click<0) {*click=click_max;}
         }  
       }
     }
    else button[button_index].cursor_on_button_area=false;
  
    //         
    if (button[button_index].cursor_on_button_area==false and
        button[button_index].click_button_area==true) 
     {button[button_index].click_button_area=false;}

   }
 }  


//    
void KeyButton_float(int button_index, 
                     SDL_Event event,
                     float mouse_X,
                     float mouse_Y,
                     float *click,
                     float click_delta, 
                     float click_max)
 { 
  if (button[button_index].on_screen==true)
   {
    if (mouse_X>button[button_index].x-0.5*button[button_index].dx and 
        mouse_X<button[button_index].x+0.5*button[button_index].dx and 
        mouse_Y>button[button_index].y-0.5*button[button_index].dy and
        mouse_Y<button[button_index].y+0.5*button[button_index].dy)
     { 
      button[button_index].cursor_on_button_area=true;
      //  
      if (event.type == SDL_MOUSEBUTTONDOWN and
          event.button.state == SDL_PRESSED)// !!
       {
        if(event.button.button == SDL_BUTTON_LEFT) 
         {
          button[button_index].click_button_area=not button[button_index].click_button_area;//   

          *click=*click+click_delta;
          //  
          if (click_delta>0 and
             *click>click_max) {*click=0;}
        //  
          if (click_delta<0 and
             *click<0) {*click=click_max;}
         }  
       }
     }
    else button[button_index].cursor_on_button_area=false;
  
    //         
    if (button[button_index].cursor_on_button_area==false and
        button[button_index].click_button_area==true) 
     {button[button_index].click_button_area=false;}

   }
 } 


// 
void DrawButton(int button_index,float R, float G, float B)
 {
  if (button[button_index].on_screen==true)
   {
    glColor3d(R,G,B);
    glEnable(GL_TEXTURE_2D);   
    glBindTexture(GL_TEXTURE_2D, button[button_index].texture);
    DrawTXT(button[button_index].x,
            button[button_index].y,
            button[button_index].dx-5*button[button_index].click_button_area,
            button[button_index].dy-5*button[button_index].click_button_area,0,1);
    glDisable(GL_TEXTURE_2D); 
    glColor3d(1,1,1);
   }
 }

//    
void LightButton(int button_index, 
                 float mouse_X, 
                 float mouse_Y, 
                 int win_DX,
                 int win_DY,
                 float R, float G, float B)
 { 
  if (button[button_index].on_screen==true and
      button[button_index].cursor_on_button_area==true) 
   {
    //    
    glColor3d(R,G,B);
    glEnable(GL_TEXTURE_2D);   
    glBindTexture( GL_TEXTURE_2D, panel_cursor_texture);
    DrawTXT(button[button_index].x,
            button[button_index].y,
            button[button_index].dx+5,
            button[button_index].dy+5,0,1);
    glDisable(GL_TEXTURE_2D); 
    glColor3d(1,1,1);


/*
    //   
    glEnable(GL_TEXTURE_2D);   
    GlTxt(300,16,fonts[1],txtColorWhite,button[button_index].name,t_txt[1]);
    glBindTexture( GL_TEXTURE_2D, t_txt[1]);
    
   // glColor3d(1,1,1);
    if (mouse_X<win_DX/2)
     {DrawTXT(mouse_X,mouse_Y,300,16,0,0);}

    if (mouse_X>=win_DX/2)
     {DrawTXT(mouse_X-160,mouse_Y,300,16,0,0);}

    glDisable(GL_TEXTURE_2D); 
*/


   }
 }



void Kill_Button(int button_index)
 {
  button[button_index].on_screen=false;
  button[button_index].cursor_on_button_area=false;
 }

int i_temp;

//    
void Mouse_Button_Index(int *mouse_index)
 { 
  for(i_temp=1; i_temp <= button_max; i_temp++) 
   {
    if (button[i_temp].on_screen==true and
        button[i_temp].cursor_on_button_area==true)
     {
      *mouse_index=i_temp;//          
      mouse_on_button_area=true;
      break;
     }
    else
     {
      *mouse_index=1;//    
       mouse_on_button_area=false;
     }
   }

 }

// 
void InitOther() //       
 {
  // 
  //   
  load("data/img/other/cursor.png", panel_cursor_texture);
  //  
/*  load("data/button/area1.png", area_texture[1]);
  load("data/button/area2.png", area_texture[2]);*/

 }


//  ()
void DrawArea(int x,int y,int dx,int dy,int n_txt,float R, float G, float B)
 {
  glColor3d(R,G,B);
  glEnable(GL_TEXTURE_2D);   
  glBindTexture(GL_TEXTURE_2D, area_texture[n_txt]);
  DrawTXT(x,y,dx,dy,0,0);
  glDisable(GL_TEXTURE_2D); 
  glColor3d(1,1,1);
 }




