#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <string.h>

#include <gl.h>
#include <glu.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

using namespace std;//ХЗ что это но с ним заработал строковый тип string

int win_DX,//=1024,//размеры окна по X
    win_DY,//=768;//размеры окна по Y
    pal,//палитра
    full_screen,//на полный экран или нет
    fps_wish;//желаемый ФПС

int done=0,//переменная отвечающая за окончание Великого рендера
    game_stage=0;//переменная определяющая что происходит в игре

int title_show,//титульник
    title_menu,//главное меню
 
    game_init,//инициация для новой игры
    game_show,//игра
    game_menu,//меню в игре
    game_return,//возвращение в игру
    game_exit,//выход из игры втитульник
    
    edit_init,//аналогично в редакторе
    edit_show,
    edit_menu,
    edit_return,
    edit_exit;    


int i,j,k,l,m,n,o,p;//переменные циклов

//мышь
float mouse_X,//координаты мышки
      mouse_Y;
bool mouse_LB,mouse_RB;//о нажиме на левые и правые кнопки мыши 

SDL_Surface *screen,//Экран
            *surface;//SDL поверхность

SDL_Event event;// SDL событие

Uint8* keys;//для управления клавиатурой

GLuint background_texture;//задний фон

#include "graph.h"//модуль графики

#include "game.h"//игровой модуль

void LoadConfFile()//грузим конфигурационный файл
 {
  //Загружаем параметры карты
  ifstream data_file;//файловый поток
  string line,//строчка в файле
         set,//определитель
         val;//значение

  //открываем файл данных
  sprintf(buff,"splex.cfg");
  data_file.open(buff);
 
  if(data_file.is_open())//если файл открылся, то
   {
    while(!data_file.eof())//пока не дойдем до конца файла
     {
      getline(data_file, line);//забиваем содержание файла в строчку
 
      if(line.find('=') != string::npos)//ищем в полученной строчке параметры  
       {
        set=line.substr(0,line.find('='));//от 0 символа в строке до "="
        val=line.substr(line.find('=')+1);//значение после "="
     
        if (set=="win_DX")
           {win_DX=atoi(val.data());} 
        else 

        if (set=="win_DY")
           {win_DY=atoi(val.data());} 
        else 

        if (set=="pal")
           {pal=atoi(val.data());} 
        else 

        if (set=="full_screen")
           {full_screen=atoi(val.data());} 
        else 

        if (set=="fps_wish")
           {fps_wish=atoi(val.data());} 
        else 

        if (set=="grid")
           {grid=atoi(val.data());} 
        else 

         //если не понимаем чтото то ругаемся на это
         {
          cout << "I did not understand the '"<<set<<"'" << endl;
         }

       }//конец условия "ищем в полученной строчке параметры"
     }//конец while
    data_file.close();//закрываем файл
   }//конец условия 

  else 
   {
    cout << "Config file not found" << endl;
   }
 }


void Title_Init()
 {
  
//В начале игры видим только титульник и гланое меню
  title_show=1;
  title_menu=1;   

//Загрузка заднего фона  титульника
  load("data/img/bground/main_back.jpg",background_texture);
 }


//Главный BEGIN
int main()
 {
  LoadConfFile();//грузим конфигурационный файл

  srand(time(NULL));//randomize;-включить счетчик случайных чисел <iostream.h>

//Инициализация SDL(видео) 
  if (SDL_Init(SDL_INIT_VIDEO)!=0) 
   {
    printf("Unable to initialize SDL: %s\n",SDL_GetError());
    return 1;
   }

  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1);

  if (full_screen==0)
   {screen=SDL_SetVideoMode(win_DX,win_DY,pal,SDL_OPENGL);}//экран OpenGl на полный экран
  if (full_screen==1)
   {screen=SDL_SetVideoMode(win_DX,win_DY,pal,SDL_OPENGL|SDL_FULLSCREEN);}//экран OpenGl в окне


  if (!screen) 
   {
    printf("Unable to set video mode: %s\n",SDL_GetError());
    return 1;
   }

//Текст и иконка в титульнике окна программы
  SDL_WM_SetCaption("SupaPlex","splex");
  SDL_WM_SetIcon(SDL_LoadBMP("data/img/other/icon.bmp"),NULL);
     
//Устанавливаем режим 2D для OpenGL
  glClearColor(0,0,0,0); //задний цвет фона черный (R,G,B,alpha)
  glEnable(GL_TEXTURE_2D); //надо для вывода текстуры
  gl2dMode(win_DX,win_DY);

//Включаем альфа канал
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_BLEND);

//инициализируем шрифт
  TTF_Init();
  TTF_TextInit();

  InitFps();//инициализация ФПС

//подцветка кнопок
  InitOther();


//Инициализация кнопок

//кнопки основного меню
  InitButton("New Game",//имя кнопки
             "data/img/buttons/button1.png",//адрес картинки
             1,//номер кнопки
             win_DX/2,//координаты
             0+4*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);

  InitButton("Level Editor",//имя кнопки
             "data/img/buttons/button2.png",//адрес картинки
             2,//номер кнопки
             win_DX/2,//координаты
             0+5*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);

  InitButton("Option",//имя кнопки
             "data/img/buttons/button3.png",//адрес картинки
             3,//номер кнопки
             win_DX/2,//координаты
             0+6*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);

  InitButton("About",//имя кнопки
             "data/img/buttons/button4.png",//адрес картинки
             4,//номер кнопки
             win_DX/2,//координаты
             0+7*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);

  InitButton("Exit To System",//имя кнопки
             "data/img/buttons/button5.png",//адрес картинки
             5,//номер кнопки
             win_DX/2,//координаты
             0+8*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);

//новые кнопки в меню игры
  InitButton("Return To Game",//имя кнопки
             "data/img/buttons/button6.png",//адрес картинки
             6,//номер кнопки
             win_DX/2,//координаты
             0+4*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);

  InitButton("Return to Main Menu",//имя кнопки
             "data/img/buttons/button7.png",//адрес картинки
             7,//номер кнопки
             win_DX/2,//координаты
             0+8*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);



//новые кнопки в меню редактора - c 31 номера
  InitButton("Return To Editor",//имя кнопки
             "data/img/buttons/button6.png",//адрес картинки
             31,//номер кнопки
             win_DX/2,//координаты
             0+4*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);

  InitButton("Return to Main Menu",//имя кнопки
             "data/img/buttons/button7.png",//адрес картинки
             32,//номер кнопки
             win_DX/2,//координаты
             0+8*win_DY/12,
             win_DX/1.28,//800 размеры
             win_DY/12,//64
             true);



//Очищаем экран перед рисованием
  glClear(GL_COLOR_BUFFER_BIT);

  Title_Init();

//=================
//=[ОСНОВНОЙ ЦИКЛ]=
//=================
  while(done == 0)
   {


//Подсчет ФПС
    SolveFps();

//Вводится задержка для соблюдения определенного ФПС
    Delay_by_Fps(fps_wish);



    //========
    //=[ИГРА]=-инициация и рефреш
    //========

    if (game_init==1)//инициация игры
     {
      title_show=0;//отключаем титульник
      title_menu=0;//отключаем главное меню    

      InitGame();
      Load_Game_Textures();
      num_level=1;//начинаем с первого уровня
      Load_Level(num_level);
     
      Player_Start();

      game_init=0;//инициация игры завершена
      game_show=1;//включаем игру
     }

    if (game_show==1 and
        game_menu==0) //во время игры-рефреш
     { 
      Matrix_ReFresh();//обновляем матрицы
     }
    
    if (game_exit==1 and //если выходим из игры
        game_menu==1)
     {
      game_show=0;
      game_menu=0;
      game_exit=0;
      
      Title_Init();
     } 

    //========
    //========


    //============
    //=[РЕДАКТОР]=-инициация и рефреш
    //============

    if (edit_init==1)//инициация игры
     {
      title_show=0;//отключаем титульник
      title_menu=0;//отключаем главное меню    

      Edit_Init();

      edit_init=0;//инициация редактора завершена
      edit_show=1;//включаем редактор
     }

    if (edit_show==1 and
        edit_menu==0) //во время игры-рефреш
     { 
      Matrix_ReFresh();//обновляем матрицы
     }
    
    if (edit_exit==1 and //если выходим из редактора
        edit_menu==1)
     {
      edit_show=0;
      edit_menu=0;
      edit_exit=0;
      
      Title_Init();
     } 

    //========
    //========



//Обрабатываем событие с клавиатуры
    while(SDL_PollEvent(&event))
     { 
      if (event.type==SDL_QUIT) {done=1;}//на выход по закрытию программы нажав на конпку на окне 

      //Управление мышкой
      if(event.type == SDL_MOUSEMOTION)//получаем мышиные координаты
       {
        mouse_X = event.motion.x;
        mouse_Y = event.motion.y;
       }

      //Обработка сигналов с мыши
      if (event.type==SDL_MOUSEBUTTONDOWN and
          event.button.state==SDL_PRESSED)//однократное нажатие на кнопку мыши
       {
        if(event.button.button == SDL_BUTTON_LEFT)//если была нажата левая кнопка
          {mouse_LB=true;} 

        if(event.button.button == SDL_BUTTON_RIGHT)//если была нажата правая кнопка
          {mouse_RB=true;}        
       }



      //Управление кнопками в главном меню титульника
      if (title_show==1 and
          title_menu==1)
       {
        //начать игру 
        KeyButton_int(1,event,mouse_X,mouse_Y,&game_init,1,99);
        //включить редактор 
        KeyButton_int(2,event,mouse_X,mouse_Y,&edit_init,1,99);
        //выход в систему
        KeyButton_int(5,event,mouse_X,mouse_Y,&done,1,99);
       }

        //========
        //=[ИГРА]=-кнопки меню
        //========

      if (game_show==1 and //в меню во время игры
          game_menu==1)
       {
        //вернуться в игру 
        KeyButton_int(6,event,mouse_X,mouse_Y,&game_menu,-1,99);
        //вернуться в главное меню
        KeyButton_int(7,event,mouse_X,mouse_Y,&game_exit,1,99);
       }

        //========
        //========



        //============
        //=[РЕДАКТОР]=-кнопки меню
        //============

      if (edit_show==1 and //в меню во время игры
          edit_menu==1)
       {
        //вернуться в игру 
        KeyButton_int(31,event,mouse_X,mouse_Y,&edit_menu,-1,99);
        //вернуться в главное меню
        KeyButton_int(32,event,mouse_X,mouse_Y,&edit_exit,1,99);
       }

        //========
        //========



      //Управление с клавиатуры
      if (event.type==SDL_KEYDOWN)//еcли нажата кнопка на клавиатуре-однократное нажатие
       {

        //========
        //=[ИГРА]=-однократное нажатие
        //========
        if (game_show==1) //во время игры
         {
          if (event.key.keysym.sym==SDLK_ESCAPE)//в игре можем включить меню по нажатию ESC
           {
            game_menu=not game_menu;
           }

          if (game_menu==0)//когда меню отключено 
           {
            Player_Controls_KeyClick();//управление колобком 
           }  

         }

        //========
        //========

        //============
        //=[РЕДАКТОР]=-однократное нажатие
        //============
        if (edit_show==1) //во время редактирования
         {
          if (event.key.keysym.sym==SDLK_ESCAPE)//в редакторе можем включить меню по нажатию ESC
           {
            edit_menu=not edit_menu;
           }

          if (edit_menu==0)//когда меню отключено 
           {
            Edit_Controls();//клавиши управления редактором
           }  

         }

        //========
        //========






       }
     } 
    
    keys = SDL_GetKeyState(NULL);

    //========
    //=[ИГРА]=-постоянное нажатие и обработка
    //========


    if (game_show==1 and//во время игры вне меню
        game_menu==0)
     { 
      Player_Controls_KeyDown();
      Player_Render_Move();//Обработка движений колобка
      Player_Render_CollisionLevObj();//Обработка столконвений колобка c lev и obj
      Object_Render_Exit();//если вихрь заходит на спец выход то дохнет, а очки на выход уменьшаються
      Object_Render_Teleport();//Взаимодействие объекта с телепортом
      Object_Render_Stage1();//Проверка возможности перемещения объекта
      Object_Render_Stage2();//Взаимодействие объектов типа obj=1,2 с колобком
      Object_Render_Stage3();//Старт движения и псевдо АИ(поведение) объектов
      Object_Render_Stage4();//Анимация и движение объектов

      Player_Render_Dead();//Повреждение колобка от бомбы и вихря
      PlayerEatObject();//Колобок ест бонусы (obj=1) и собирает при этом очки
      Object_Render_Dead();//Смерть объектов
     }

    //========
    //========


    //============
    //=[РЕДАКТОР]=-постоянное нажатие и обработка
    //============


    if (edit_show==1 and//во время редактирования вне меню
        edit_menu==0)
     { 
      Cam_Controls_KeyDown();//управление камерой с клавиатуры
     }

    //========
    //========



//Задний фон

    glBindTexture(GL_TEXTURE_2D,background_texture);
    DrawTXT(win_DX/2,win_DY/2,win_DX,win_DY,0,1);


    //========
    //=[ИГРА]=-вывод графики
    //========

    if (game_show==1)//во время игры

     { 
      Level_Draw();//Рисуем уровень
      Portals_Draw();//Рисуем телепорты
      Object_Draw();//Рисуем объекты
      Player_Draw();//Рисуем колобка
      Effect_Draw();//Рисуем эффекты
      HUD_Draw();//Рисуем ХУД
     }


    //========
    //========

    //============
    //=[РЕДАКТОР]=-вывод графики
    //============

    if (edit_show==1)//во время игры

     { 
      Level_Draw();//Рисуем уровень
      Object_Draw();//Рисуем объекты

      Cursor_Draw();//Рисуем курсор редактора 

      Other_Draw();//вывод прочего

     }

    //========
    //========


    //Вывод кнопок главного меню в титульнике
    if (title_show==1 and
        title_menu==1)
     {
      DrawButton(1,1,1,1);LightButton(1,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
      DrawButton(2,1,1,1);LightButton(2,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
      DrawButton(3,1,1,1);LightButton(3,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
      DrawButton(4,1,1,1);LightButton(4,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
      DrawButton(5,1,1,1);LightButton(5,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
     }


    //========
    //=[ИГРА]=-вывод меню
    //========

    //Вывод кнопок меню в игре
    if (game_show==1 and
        game_menu==1) 
     {
      DrawButton(6,1,1,1);LightButton(6,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
      DrawButton(7,1,1,1);LightButton(7,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
     }

    //========
    //========

    //============
    //=[РЕДАКТОР]=-вывод меню
    //============

    //Вывод кнопок меню в игре
    if (edit_show==1 and
        edit_menu==1) 
     {
      DrawButton(31,1,1,1);LightButton(31,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
      DrawButton(32,1,1,1);LightButton(32,mouse_X,mouse_Y,win_DX,win_DY,1,1,1);
     }

    //========
    //========

    glColor4f(1,1,1,1);
    glEnable(GL_TEXTURE_2D);



//!! cout вызывают тормоза в цикле
//    cout <<"fps=" << fps <<"\n";

    SDL_GL_SwapBuffers();

   }//конец великого РЕНДЕРА

    // Теперь можно стереть все сгенеренные текстуры и отключить SDL
    //    glDeleteTextures( 1, &player_texture[1] );
  
    SDL_Quit();
    
    return 0;

 }//конец BEGIN

